<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../google-apis/google-client-loader.html">
<link rel="import" href="../hook-date-behavior/hook-date-behavior.html">

<!--
`<hook-calendar-data>` is an element for pulling google calendar data.

### Example:

    <hook-calendar-data api-key="apiKey" calendar-id="calendarId"></hook-calendar-data>

@element hook-calendar-data
-->

<dom-module id="hook-calendar-data">

  <template strip-whitespace>

    <!-- client loader -->

    <google-client-loader id="calendar" name="calendar" version="v3"
     on-google-api-load="_onLoad" on-google-api-load-error="_onError"></google-client-loader>

  </template>

  <script>
    Polymer({

      is: 'hook-calendar-data',

      behaviors: [DateBehaviors.EventsBehavior],

      properties: {
        /**
         * API key
         */
        apiKey: {
          type: String,
          notify: true,
          reflectToAttribute: true
        },
        /**
         * Calendar ID
         */
        calendarId: {
          type: String,
          notify: true,
          reflectToAttribute: true
        },
        /**
         * Date
         */
        dateMin: {
          type: Date
        },
        /**
         * Array that holds all of the events.
         */
        events: {
          type: Array,
          notify: true,
          value: function() {
            return [];
          }
        },
        /**
         * Loaded boolean
         */
        loaded: {
          type: Boolean,
          notify: true,
          value: false
        }
      },

      /**
       * Observer for when events array changes.
       */
      observers: [
        '_eventsChanged(events.*)'
      ],

      /**
       * On load callback
       * @private
       */
      _onLoad: function() {

        this.request();

      },

      /**
       * On error callback
       * @private
       */
      _onError: function() {},

      /**
       * Verify request and call processRequest.
       * @private
       */
      request: function() {

        if (this.$.calendar.api) {

          if (this.apiKey) {
            gapi.client.setApiKey(this.apiKey);
          }

          var params = {
            calendarId: this.calendarId,
            timeMin: (new Date()).toISOString()
          };

          var request = this.$.calendar.api.events.list(params);

          request.execute(function(response) {
            this.cancelDebouncer('calendarRequest');
            this.set('loaded', true);
            this._processResponse(response.items);
          }.bind(this), function(err){
            this.set('loaded', true);
            this.events = [];
          }.bind(this));

          this.debounce('calendarRequest', this._requestTimeout.bind(this), 5000);

        }

      },

      /**
       * Timeout callback
       * @private
       */
      _requestTimeout: function() {

        this.set('loaded', true);
        this.events = [];

      },

      /**
       * Set up events array and push items into array.
       * @private
       */
      _processResponse: function(items) {

        var processedEvents = items.map(function(item) {
          return this._processResponseItem(item);
        }, this);

        var events = this.events;

        this.set('events', events.concat(processedEvents));

      },

      /**
       * Create event object from response data.
       * @private
       */
      _processResponseItem: function(item) {

        if (!item.start.dateTime || !item.end.dateTime) {
          return;
        }

        var event = {};
        event.__event = item;
        event.title = item.summary ? item.summary : 'No summary available.';
        event.location = item.location ? item.location : 'No location available.';
        event.desc = item.description ? item.description : 'No description available.';

        var startDate = new Date(item.start.dateTime);
        var endDate = new Date(item.end.dateTime);

        event.start = {
          date: startDate,
          dateText: this._getDateDayString(startDate),
          monthText: this._getDateMonthString(startDate)
        };

        event.end = {
          date: endDate,
          dateText: this._getDateDayString(endDate),
          monthText: this._getDateMonthString(startDate)
        };

        return event;

      },

      /**
       * If an event was selected, deselect the others.
       * @private
       */
      _eventsChanged: function(cr) {

        var events = cr.base;
        var path = cr.path;
        var value = cr.value;

        this._onlyOneTrueValue(events, path, value, 'selected');

        var visibleIndex = path.indexOf('.visible');

        if (visibleIndex > -1 && value === false) {
          events.map(function(event, index) {
            this.set('events.' + index + '.selected', false);
          }, this);
        }

      },

      /**
       * Only allow one event with a true value for the property.
       * @private
       */
      _onlyOneTrueValue: function(events, path, value, keyname) {

        var index = path.indexOf('.' + keyname);

        if (index > -1 && value === true) {
          var itempath = path.substring(0, index);
          var item = this.get(itempath);
          var index = events.indexOf(item);

          events.map(function(event, index) {
            if (event !== item) {
              this.set('events.' + index + '.' + keyname, false);
            }
          }, this);
        }

      }

    });
  </script>

</dom-module>
